/* Padico Advanced Examples
 * author: Christian Prez
 */

#include <stdio.h>
#include "mpi.h"
#include "XService.h"

int main(int argc, char **argv)
{
  int  myid, numprocs;
  int bsz, llen, glen; /* local & globals size of 1D block-distributed array */
  xservice_data_t *data;
  int base;

  MPI_Init(&argc, &argv); 
  MPI_Comm_size(MPI_COMM_WORLD,&numprocs);
  MPI_Comm_rank(MPI_COMM_WORLD,&myid);
  
  fprintf(stderr, "[MPServer] I am process %d/%d\n", myid, numprocs);

  register1D(myid, numprocs, "XExemple");

  while(myWaitDataBlock1D(&data, &llen, &glen)) {
    
    bsz = blockSize(glen,numprocs);
    base = myid*bsz;
    
    fprintf(stderr,"[%d] checksum from %d to %d = %ld\n", myid, base, base+llen, checksum(data, llen));
  }
   
  unregister1D(myid);

  MPI_Finalize();
  fprintf(stderr, "[MPServer] ok\n");

  return 0;
}

