#!/bin/sh

MACHINE1=l
M1="1 2"
MACHINE2=l
M2="3"

usage() {

cat <<EOF
   run.sh [init|finalize]
   run.sh server
   run.sh client <vector size>
EOF

exit 0

}

init() {
    set $M1
    NL1=${MACHINE1}$1
    shift
    for i; do 
	NL1="${NL1},${MACHINE1}$i"
    done

    set $M2
    NL2=${MACHINE2}$1
    shift
    for i; do
	NL2="${NL2},${MACHINE2}$i"
    done

    padico-mpirun-adv init g1 -nodelist $NL1
    padico-mpirun-adv init g2 -nodelist $NL2

}

finalize() {

    for i in $M1; do
	padico-run -u XService $MACHINE1$i
    done

    for i in $M2; do
	padico-run -u XService $MACHINE2$i
    done

    padico-mpirun-adv finalize g1
    padico-mpirun-adv finalize g2

}

client() {
    padico-mpirun-adv run g1 MPClient $1 &
}

server() {
    padico-mpirun-adv run g2 MPServer &
}

if [ $# -lt 1 ]; then usage; fi

case $1 in 

    start)
	finalize
	init
	server;;
    init)
	init;;
    client)
	shift
	if [ $# -lt 1 ]; then usage; fi
	client $1;;
    server)
	server;;
    finalize)
	finalize;;
    *)
       usage;;
esac