/** @file
 * @brief Dynamic Library management portability layer 
 * @ingroup Puk
 */

#ifndef PUK_DYLIB_H
#define PUK_DYLIB_H

#include <fcntl.h>

#ifndef RTLD_DEFAULT
#  define RTLD_DEFAULT NULL
#endif
#ifndef RTLD_NEXT
# define RTLD_NEXT ((void *) -1l)
#endif

#define PUK_DYLIB_DEFAULT_MODE   (RTLD_NOW | RTLD_GLOBAL)
#define PUK_DYLIB_DEFAULT_HANDLE  RTLD_DEFAULT
#define PUK_DYLIB_NEXT_HANDLE     RTLD_NEXT

void*puk_dylib_open(const char *pathname, int mode);
int  puk_dylib_close(void *handle);
char*puk_dylib_error(void);
void*puk_dylib_resolve(void*handle, const char*symbol);




#endif /* PUK_DYLIB_H */
