
AC_DEFUN([AC_PADICO_OUT_PUK],
	 [ dnl --- Puk/
	   out_mk="${out_mk} Makefile Puk.pc Puk.gdbinit"
	   dnl --- Puk/ModulesTools/
	   out_mk="${out_mk} ModulesTools/Makefile ModulesTools/padico-core-wrapper.sh"
	   out_sh="${out_sh} ModulesTools/padico-mkmod ModulesTools/padico-cc ModulesTools/padico-cdep ModulesTools/padico-config"
	 ])

AC_DEFUN([AC_PADICO_OUT_PUK_BUILD],
	 [
	   common_vars_mk=${padico_builddir}/common_vars.mk
	   AC_SUBST_FILE(common_vars_mk)
	   out_mk="common_vars.mk $out_mk"

	   common_rules_mk=${padico_builddir}/common_rules.mk
	   AC_SUBST_FILE(common_rules_mk)
	   out_mk="common_rules.mk $out_mk"
	  ])


# ## check how to disable std lib linkage
# used by padico-mkmod
AC_DEFUN([AC_PADICO_NOSTDLIB],
	 [ AC_REQUIRE([AC_PADICO_LINKER])
	   AC_MSG_CHECKING([for nostdlib ld flag])
	   case ${LD} in
	     *c++*|*g++*|*gcc*|*clang*|*icc*) LDNOSTDLIB="";; # LDNOSTDLIB="-nostdlib";;
	     'CC')  LDNOSTDLIB="-z muldefs";;
	     *) AC_MSG_ERROR([Unknown C++ linker: ${LD}. Stop.])
	   esac
	   AC_MSG_RESULT([${LDNOSTDLIB}])
	   AC_SUBST(LDNOSTDLIB)
	 ])



# ## how to convert a static library into a shared object file
# used by padico-mkmod
AC_DEFUN([AC_PADICO_ATOSO],
	 [ AC_REQUIRE([AC_PADICO_COMPILER]) 
	   AC_MSG_CHECKING([ whether static libraries can be converted into dynamic libraries ]) 
	   libm_a=`${CC} -print-file-name=libm.a`
	   if test -r ${libm_a} ; then
	     _LOCALLIBA=${libm_a}
	   else
	     _LOCALLIBA=`echo /usr/lib/lib*.a | cut -f 1 -d ' '`
	     if test ! -r ${_LOCALLIBA} ; then
	       AC_MSG_WARN([ Unable to find a lib.a in /usr/lib ])
	     fi
	   fi
	   _LOCALLIBSO=test.so
	   atoso_flags_gnu="-shared -export-dynamic -whole-archive -fPIC"
	   atoso_flags_bsd="-G z allextract"
	   ATOSO_OK="yes"
	   if ( ld ${atoso_flags_gnu} ${_LOCALLIBA} -o ${_LOCALLIBSO} 1> /dev/null 2>&1 ); then
	     ATOSO="ld ${atoso_flags_gnu}";
	   elif ( gnu-ld ${atoso_flags_gnu} ${_LOCALLIBA} -o ${_LOCALLIBSO} 1> /dev/null 2>&1 ); then
	     ATOSO="gnu-ld ${atoso_flags_gnu}";
	   elif ( ld ${atoso_flags_bsd} ${_LOCALLIBA} -o ${_LOCALLIBSO}  1> /dev/null 2>&1 ); then
	     ATOSO="ld ${atoso_flags_bsd}";
	   else
	     ATOSO="";
	     ATOSO_OK="no";
	   fi
	   if test -r ${_LOCALLIBSO} ; then rm ${_LOCALLIBSO}; fi
	   AC_MSG_RESULT([${ATOSO_OK}: ${ATOSO} ])
	   AC_SUBST(ATOSO)
	   AC_SUBST(ATOSO_OK)
	 ])
