/** @file Puk configuration.
 * @note this file must not include any libc header
 */

#ifndef PUK_CONFIG_H
#define PUK_CONFIG_H

/* include autoconf'ed configuration */
#ifndef PADICO_BUILD_STRING
#  include "padico_config.h"
#endif

/** @todo isn't there a better place to define PADICO? */
#ifndef PADICO
#  define PADICO
#endif

/* *** Typing ********************************************** */

/* use these macros to display size_t and ssize_t in 
 * a portable (32/64 bits) way */
#define puk_ulong(N) ((unsigned long)(N))
#define puk_slong(N) ((long)(N))
/** convert a long to pointer */
#define puk_long2ptr(N) ((void*)(long)N)
/** convert a pointer to a long */
#define puk_ptr2long(P) ((long)(P))

/* we need socklen_t */
#ifndef HAVE_SOCKLEN_T
typedef int socklen_t;
#endif

#ifndef NULL
#  define NULL ((void*)0)
#endif


/* *** String mangling ************************************* */

#define _TOSTRING(NAME) #NAME
#define _PASTE(N1, N2) N1 ## N2
#define _PASTE3(N1, N2, N3) N1 ## N2 ## N3


/* *** Linking ********************************************* */

#define __PUK_SYM_INTERNAL __attribute__ ((visibility("internal")))


#endif /* PUK_CONFIG_H */
